#!/usr/bin/python
# -*- coding: utf-8 -*-

# python -m pip install pyserial
# sudo ntpdate -u time.apple.com


import datetime
import time
import serial
import sys

CMD_SYNC = 0
CMD_RESET = 1
CMD_GET_TIME = 2
CMD_GET_FCPU = 3

#port_name = '/dev/tty.wchusbserial1420'
#port_name = '/dev/tty.usbserial-14201'
port_name = '/dev/tty.usbserial-14101'
bauds = 153600

t0 = datetime.datetime.now()

def write_byte(b):
	global serial
	# print '>> ', b
	serial.write(chr(b))

def read_byte():
	global serial
	b = ord(serial.read())
	# print '<< ', b
	return b

def read_word():
	return (read_byte() << 8) + read_byte()

def read_dword():
	return (read_byte() << 24) + (read_byte() << 16) + (read_byte() << 8) + read_byte()	

def read_time():
	write_byte(CMD_GET_TIME)
	msec = read_word()
	sec = read_dword()
	return sec + 1.0*msec/1000.0

def get_system_time():
	global t0
	return (datetime.datetime.now() - t0).total_seconds()

def reset_time():
	global t0
	write_byte(CMD_RESET)
	t0 = datetime.datetime.now()

def connect():
	global serial
	serial = serial.serial_for_url(port_name, baudrate=bauds, timeout=0.5)
	print 'Reading device'
	while True:
		try:
			b = read_byte()
		except:
			break
	#print 'sync <- '
	write_byte(CMD_SYNC)
	write_byte(10)
	res = read_byte()
	#print 'sync -> ', res
	if (res != 10):
		print 'sync error'
		sys.exit(1)

def get_fcpu():
	write_byte(CMD_GET_FCPU)
	return read_dword()
	

print 'connecting...'
connect()
print 'connected'
reset_time()

f_cpu = get_fcpu()
print 'F_CPU:', f_cpu
while True:
	time.sleep(10);
	system_t = get_system_time()
	device_t = read_time()
	print 'System:', system_t, 'Device:', device_t, 'Ratio:', 100.0*device_t / system_t, '%', '\t f = (' + str(1.0*f_cpu*device_t / system_t) + ' Hz)'
	
